Option Explicit

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' Excel}l[WNX
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Class ExcelManager

    'bZ[W
    Private mstrMessage

    'ExcelubN
    Private mstrBookName

    'ExcelV[g
    Private mstrSheetName

    'ExcelAvP[VIuWFNg
    Private mobjXls

    'ExcelubNIuWFNg
    Private mobjBook

    'ExcelV[gIuWFNg
    Private mobjSheet

    'RXgN^
    Private Sub Class_Initialize()
        mstrMessage = ""

        Set mobjXls = CreateObject("Excel.Application")
    End Sub

    'fXgN^
    Private Sub Class_Terminate()
        mobjXls.Quit

        Set mobjSheet = Nothing
        Set mobjBook = Nothing
        Set mobjXls = Nothing
    End Sub

    '************************************************************
    ' vpeBFMessage
    ' Tv@@@@FbZ[W
    '************************************************************
    Public Property Get Message()
        Message = mstrMessage
    End Property
    Private Property Let Message(ByVal strMsg)
        mstrMessage = strMsg
    End Property

    '************************************************************
    ' vpeBFBookName
    ' Tv@@@@FExcelubN
    '************************************************************
    Public Property Get BookName()
        BookName = mstrBookName
    End Property
    Public Property Let BookName(ByVal strBookNm)
        On Error Resume Next

        ExcelApplication.Workbooks.Open strBookNm, 0, True

        If Not (Err.Number = 0) Then
            Message = CStr(Err.Number) & ":" & Err.Description
            Err.Clear
            Exit Property
        End If

        ExcelBook = ExcelApplication.ActiveWorkbook

        On Error GoTo 0

        mstrBookName = strBookNm
    End Property

    '************************************************************
    ' vpeBFSheetName
    ' Tv@@@@FExcelV[g
    '************************************************************
    Public Property Get SheetName()
        SheetName = mstrSheetName
    End Property
    Public Property Let SheetName(ByVal strSheetNm)
        On Error Resume Next

        ExcelSheet = ExcelBook.Worksheets(strSheetNm)

        If Not (Err.Number = 0) Then
            Message = CStr(Err.Number) & ":" & Err.Description
            Err.Clear
            Exit Property
        End If

        On Error GoTo 0

        mstrSheetName = strSheetNm
    End Property

    '************************************************************
    ' vpeBFExcelApplication
    ' Tv@@@@FExcelAvP[VIuWFNg
    '************************************************************
    Private Property Get ExcelApplication()
        Set ExcelApplication = mobjXls
    End Property
    Private Property Let ExcelApplication(ByVal objXls)
        Set mobjXls = objXls
    End Property

    '************************************************************
    ' vpeBFExcelBook
    ' Tv@@@@FExcelubNIuWFNg
    '************************************************************
    Private Property Get ExcelBook()
        Set ExcelBook = mobjBook
    End Property
    Private Property Let ExcelBook(ByVal objBook)
        Set mobjBook = objBook
    End Property

    '************************************************************
    ' vpeBFExcelSheet
    ' Tv@@@@FExcelV[gIuWFNg
    '************************************************************
    Private Property Get ExcelSheet()
        Set ExcelSheet = mobjSheet
    End Property
    Private Property Let ExcelSheet(ByVal objSheet)
        Set mobjSheet = objSheet
    End Property

    '************************************************************
    ' \bhFCloseBook
    ' Tv@@@FExcelubN
    ' p[^FȂ
    ' ߂l@@FɕȂTrueAłȂFalse
    '************************************************************
    Public Function CloseBook()
        CloseBook = False

        On Error Resume Next

        ExcelBook.Close
        If Not (Err.Number = 0) Then
            Message = CStr(Err.Number) & ":" & Err.Description
            Err.Clear
            Exit Function
        End If

        On Error GoTo 0

        CloseBook = True
    End Function

    '************************************************************
    ' \bhFGetCell
    ' Tv@@@FZ̒l擾iCellwj
    ' p[^F[intRow] - sʒu
    ' @@@@@@[iCor] - ʒu
    ' ߂l@@FYZ̒l
    '************************************************************
    Public Function GetCell(ByVal intRow, ByVal intCol)
        GetCell = ""

        On Error Resume Next

        Dim strValue
        strValue = CStr(ExcelSheet.Cells(intRow, intCol).Value)

        If Not (Err.Number = 0) Then
            Message = CStr(Err.Number) & ":" & Err.Description
            Err.Clear
        End If

        On Error GoTo 0

        GetCell = strValue
    End Function

    '************************************************************
    ' \bhFGetRange
    ' Tv@@@FZ̒l擾iRangewj
    ' p[^F[strRange] - Rangeʒu
    ' ߂l@@FYZ̒l
    '************************************************************
    Public Function GetRange(ByVal strRange)
        GetRange = ""

        On Error Resume Next

        Dim strValue
        strValue = CStr(ExcelSheet.Range(strRange).Value)

        If Not (Err.Number = 0) Then
            Message = CStr(Err.Number) & ":" & Err.Description
            Err.Clear
        End If

        On Error GoTo 0

        GetRange = strValue
    End Function

End Class
